<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Task 81.30</title>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  </head>
  <body>
    <div class="container p-2">
      <div class="row">
        <div class="col-sm-5 mx-auto">
          <div class="row">
            <div class="col-sm-12 mx-auto">
              <h2 class="mb-4">Sign-up</h2>
              <p>Please fill in this form to create an account</p>
              <hr />
              <div class="row form-group">
                <div class="col-sm-6">
                  <input
                    type="text"
                    class="form-control"
                    id="input-first-name"
                    placeholder="First name"
                  />
                </div>
                <div class="col-sm-6">
                  <input
                    type="text"
                    class="form-control"
                    id="input-last-name"
                    placeholder="Last name"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-12">
                  <input
                    type="text"
                    class="form-control"
                    id="input-email"
                    placeholder="Email"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-12">
                  <input
                    type="password"
                    class="form-control"
                    id="input-password"
                    placeholder="Password"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-12">
                  <input
                    type="password"
                    class="form-control"
                    id="input-confirm-password"
                    placeholder="Confirm password"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-12">
                  <input type="checkbox" id="checkbox-accept" />
                  <label for="checkbox-accept"
                    >I accept the Terms of use & privacy policy</label
                  >
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-12">
                  <button class="btn btn-primary" id="btn-sign-up">
                    Sign up
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
  <script>
    $('#btn-sign-up').on('click', function () {
      onBtnSignUpClick();
    });

    function onBtnSignUpClick() {
      var vUserObj = {
        firstname: '',
        lastname: '',
        email: '',
        password: '',
      };
      vUserObj.firstname = $('#input-first-name').val().trim();
      vUserObj.lastname = $('#input-last-name').val().trim();
      vUserObj.email = $('#input-email').val().trim();
      vUserObj.password = $('#input-password').val().trim();
      var vIsChecked = validateData(vUserObj);
      if (vIsChecked) {
        callApiToSignUp(vUserObj);
      }
    }

    function validateData(pUserObj) {
      var vResult = true;
      try {
        if (pUserObj.firstname === '') {
          throw 'Vui long nhap first name';
          vResult = false;
        }
        if (pUserObj.lastname === '') {
          throw 'Vui long nhap last name';
          vResult = false;
        }
        if (pUserObj.email === '') {
          throw 'Vui long nhap email';
          vResult = false;
        }
        if (pUserObj.password === '') {
          throw 'Vui long nhap password';
          vResult = false;
        }
        if (pUserObj.password !== $('#input-confirm-password').val().trim()) {
          throw 'Password khong giong nhau';
          vResult = false;
        }
      } catch (error) {
        alert(error);
      }
      return vResult;
    }

    function callApiToSignUp(pUserObj) {
      $.ajax({
        url: 'http://42.115.221.44:8080/devcamp-auth/users/signup',
        type: 'POST',
        dataType: 'json',
        contentType: 'application/json; charset=utf-8',
        data: JSON.stringify(pUserObj),
        success: function (pRes) {
          console.log(pRes);
          alert(pRes.message);
        },
        error: function (pAjaxContext) {
          console.log(pAjaxContext.responseJSON.message);
        },
      });
    }
  </script>
</html>
